from Products.ZPatterns import DataSkins
from Products.ZPatterns.Rack import Rack
from Products.PlugIns import MakePICBase
from Products.ZPatterns.DataManagers import DataManager
from Globals import DTMLFile, default__class_init__, PersistentMapping
from OFS.SimpleItem import Item_w__name__


class COMRack(Rack):
    """ this is a generic rack without the need for a ZClass as storage """

    meta_type = "COMRack"
    __plugin_kind__ = "Rack"
    icon = 'misc_/ZPatterns/rack'

    manage_storageForm = DTMLFile('www/storageForm', globals())

    def __init__(self,id='',title=''):
	""" initialize a rack """
	self.conn_id=None
	self.tablename=''
	self.id_name=''
	Rack.__init__(self,id,title)

    def _RawItem(self, key):
        """ Create an empty object of the right class """
        self = self.aq_inner
        item = COMRackDataObject()
        
        item._setRack(self)                          # Connect to rack
        item = item.__of__(self.aq_parent.aq_inner)  # Link to Specialist
        item._setId(key)
        
        return item

default__class_init__(COMRack)
    

class COMRackDataObject(Item_w__name__,DataSkins.DataSkin):
    """ dataskin extension for use without a ZClass """

    # make it visible in the rack!

    def _setId(self,id):
	self.id=id

    def set(self,n,v):
	self.__set_attr__(n,v)

    def get(self,n):
	return self.__getattr__(n)

    pass

manage_addCOMRackForm = DTMLFile('addRack', globals())

def manage_addCOMRack(self, id, title='', REQUEST=None):
    """Add a Rack"""
    ob = COMRack(id, title)
    return self.Destination()._installPlugIn(ob,'Added Rack.',REQUEST)

def initialize(context):

    context.registerPlugInClass(
        COMRack,
        permission = 'Add Racks',
        constructors = (manage_addCOMRackForm,
                        manage_addCOMRack),
        icon = 'www/rack.gif',
    )


